#include	"stdThread.h"

#include    <ifaddrs.h>
#include    <net/if.h>

int		main(void)
{
	int		iRet = 0;
	struct ifaddrs *pifaddrs = NULL, *pifa;
	char	szAddr[NI_MAXHOST], szMask[NI_MAXHOST];

// A_v^Xg̎擾
	if (getifaddrs(&pifaddrs) == -1)
		goto L_END;
// A_v^ꗗo
	pifa = pifaddrs;
	while(pifa)
	{
// AhXȂ̂͑ΏۊO
		if (pifa->ifa_addr == NULL)
			goto L_NEXT;
// IPv4/IPv6ȊO͑ΏۊO
		if ((pifa->ifa_addr->sa_family != AF_INET) && (pifa->ifa_addr->sa_family != AF_INET6))
			goto L_NEXT;

		fprintf(stderr, "Name:%s\n", pifa->ifa_name);
// C^[tF[XOCfbNX擾
		fprintf(stderr, "Index:%d\n", if_nametoindex(pifa->ifa_name));

		if (pifa->ifa_addr->sa_family == AF_INET)		// IPv4̎IPAhXƃlbg}XN𒲂ׂ
		{
			inet_ntop(AF_INET, &((struct sockaddr_in *)pifa->ifa_addr)->sin_addr, szAddr, sizeof(szAddr));
			inet_ntop(AF_INET, &((struct sockaddr_in *)pifa->ifa_netmask)->sin_addr, szMask, sizeof(szMask));
			fprintf(stderr, "  IPv4: %s netmask %s\n", szAddr, szMask);
		}
		else if (pifa->ifa_addr->sa_family == AF_INET6)	// IPv6̎IPAhXƃlbg}XN𒲂ׂ
		{
			inet_ntop(AF_INET6, &((struct sockaddr_in6 *)pifa->ifa_addr)->sin6_addr, szAddr, sizeof(szAddr));
			inet_ntop(AF_INET6, &((struct sockaddr_in6 *)pifa->ifa_netmask)->sin6_addr, szMask, sizeof(szMask));
			fprintf(stderr, "  IPv6: %s netmask %s\n", szAddr, szMask);
		}
		fprintf(stderr, "\n");
L_NEXT:
		pifa = pifa->ifa_next;
	}
	iRet = 0;
L_END:
	if (pifaddrs != NULL)
		freeifaddrs(pifaddrs);
	return(iRet);
}